
<?php

/**
 * @file
 * Contains support form for miniOrange SAML Login Module.
 */
include "includes\miniorange_saml_enum.php";

define( "Tab_Class_Names", serialize( array(
    "Identity_Provider" => 'mo_options_enum_identity_provider',
    "Service_Provider"  => 'mo_options_enum_service_provider',
    "Proxy_Setup"       => 'mo_options_enum_proxy_setup'
) ) );
/**
 * Showing Support form info.
 */
function miniorange_saml_export_config($form, &$form_state)
{
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

    global $base_url;
	
	if (variable_get('miniorange_saml_customer_admin_email', NULL) == NULL|| variable_get('miniorange_saml_customer_id', NULL) == NULL
    || variable_get('miniorange_saml_customer_admin_token', NULL) == NULL || variable_get('miniorange_saml_customer_api_key', NULL) == NULL) {
        $register_url = $base_url . '/admin/config/people/miniorange_saml/customer_setup/';
        $form['header'] = array(
            '#markup' => '<div class="mo_saml_idp_message"><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
        );
    
    return $form;
    }

    $form['markup_msg'] = array(
        '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
    );

    $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

    $form['markup_top'] = array(
        '#markup' => '<div class="mo_saml_table_layout container"><h3>Export Configuration</h3>' .'<hr/>' .'<br/>'. '<p>This tab will help you to transfer your plugin configurations when you change your Drupal instance.</p>'
            . '<p>Download plugin configuration file by clicking on the button given below and send us this file along with your support query. </p>'		
    );

    if(miniorange_saml_is_sp_configured()) {
        $form['miniorange_saml_idp_export'] = array(
            '#type' => 'submit',
            '#value' => t('Download Plugin Configuration'),
            '#prefix' => '<td>',
            '#suffix' => '</td>',
            '#submit' => array('miniorange_import_export'),
        );
    }else {
        $form['miniorange_saml_idp_export'] = array(
            '#markup' => '<div style="display:block; margin-top:10px; color:red; background-color:rgba(251, 232, 0, 0.15); font-size: medium;padding:5px;border:solid 1px rgba(255, 0, 9, 0.36);">
	                            Please <a href="' . $base_url . '/admin/config/people/miniorange_saml/sp_setup">configure the plugin</a> first to export the configurations.
                          </div>',
        );
    }

    $form['markup_import'] = array(
        '#markup' => '<br/><br/>'.'<h3>Import Configuration <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a></h3>' .'<hr/>'
            . '<p>This tab will help you to<span style="font-weight: bold"> Import your plugin configurations</span> when you change your Drupal instance.</p>'
            . '<p>choose <b>"json"</b> Extened plugin configuration file and upload by clicking on the button given below. </p>'
    );

    $form['import_Config_file'] = array(
        '#type' => 'file',
        '#disabled' => TRUE,
    );

    $form['miniorange_saml_idp_import'] = array(
        '#type' => 'submit',
        '#value' => t('Upload'),
        '#submit' => array('miniorange_import_Config'),
        '#disabled' => TRUE,
    );

    $form['markup_support_1'] = array(
        '#markup' => '</div><div class="mo_saml_table_layout_support_1"><h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
    );

    $form['miniorange_saml_email_address'] = array(
        '#type' => 'textfield',
        '#title' => t('Email Address'),
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your email'),
    );

    $form['miniorange_saml_phone_number'] = array(
        '#type' => 'textfield',
        '#title' => t('Phone number'),
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number'),
    );

    $form['miniorange_saml_support_query'] = array(
        '#type' => 'textarea',
        '#title' => t('Query'),
        '#cols' => '10',
        '#rows' => '5',
        '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here'),
    );

    $form['miniorange_saml_support_submit'] = array(
        '#type' => 'submit',
        '#value' => t('Submit Query'),
        '#submit' => array('miniorange_saml_send_query'),
    );


    return $form;
}

function miniorange_import_export() {

    $tab_class_name      = unserialize( Tab_Class_Names );
    $configuration_array = array();
    foreach ( $tab_class_name as $key => $value ) {
        $configuration_array[ $key ] = mo_get_configuration_array( $value );
    }

    $configuration_array["Version_dependencies"]=mo_get_version_informations();

    header( "Content-Disposition: attachment; filename=miniorange-saml-config.json" );
    echo( json_encode( $configuration_array, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES) );
    exit;
}

function mo_get_configuration_array( $class_name ) {
    $class_object = call_user_func( $class_name . '::getConstants' );
    $mo_array = array();

    foreach ( $class_object as $key => $value ) {

        $mo_option_exists=variable_get($value);
        if($mo_option_exists){
            if(@unserialize($mo_option_exists)!==false){
                $mo_option_exists = unserialize($mo_option_exists);
            }
            $mo_array[ $key ] = $mo_option_exists;
        }
    }
    return $mo_array;
}

function mo_get_version_informations(){
    $array_version = array();
    $array_version["PHP_version"] = phpversion();
    $array_version["Drupal_version"] = VERSION;
    $array_version["OPEN_SSL"] = mo_saml_is_openssl_installed();
    $array_version["CURL"] = mo_saml_is_curl_installed();
    $array_version["ICONV"] = mo_saml_is_iconv_installed();
    $array_version["DOM"] = mo_saml_is_dom_installed();

    return $array_version;
}

function mo_saml_is_openssl_installed() {
    if ( in_array( 'openssl', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function mo_saml_is_curl_installed() {
    if ( in_array( 'curl', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function mo_saml_is_iconv_installed(){

    if ( in_array( 'iconv', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function mo_saml_is_dom_installed(){

    if ( in_array( 'dom', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function miniorange_saml_is_sp_configured() {
    $saml_login_url  = variable_get( 'miniorange_saml_idp_login_url' );
    $saml_idp_issuer = variable_get( 'miniorange_saml_idp_issuer' );
    $saml_x509_certificate = variable_get( 'miniorange_saml_idp_x509_certificate' );
    if ( ! empty( $saml_login_url ) && ! empty( $saml_x509_certificate )  && ! empty( $saml_idp_issuer ) ) {
        return 1;
    } else {
        return 0;
    }
}
/**
 * Send support query.
 */
function miniorange_saml_send_query($form, &$form_state) {
    $email = $form['miniorange_saml_email_address']['#value'];
    $phone = $form['miniorange_saml_phone_number']['#value'];
    $query = $form['miniorange_saml_support_query']['#value'];
    $support = new MiniOrangeSamlSupport($email, $phone, $query);
    $support_response = $support->sendSupportQuery();
    if($support_response) {
        drupal_set_message(t('Support query successfully sent'));
    }
    else {
        drupal_set_message(t('Error sending support query'), 'error');
    }
}




