<?php
/**
 * @file
 * Contains Login Settings for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
 function miniorange_saml_login_options($form, &$form_state)
 {
     global $base_url;
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));



  if (variable_get('miniorange_saml_customer_admin_email', NULL) == NULL || variable_get('miniorange_saml_customer_id', NULL) == NULL
    || variable_get('miniorange_saml_customer_admin_token', NULL) == NULL|| variable_get('miniorange_saml_customer_api_key', NULL) == NULL) {
      $register_url = $base_url . '/admin/config/people/miniorange_saml/customer_setup/';
      $form['header'] = array(
          '#markup' => '<div class="mo_saml_idp_message"><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
      );

    return $form;
  }

     $form['markup_msg'] = array(
         '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
     );

  $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

  $form['markup_1'] = array(
    '#markup' => '<div class="mo_saml_table_layout container"><h2>Sign in Settings</h2><hr></br>',
  );

  $form['miniorange_saml_force_auth'] = array(
    '#type' => 'checkbox',
    '#title' => t('Protect website against anonymous access <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
    '#default_value' => variable_get('miniorange_saml_force_auth', ''),
	'#disabled' => TRUE,
  );

  $form['markup_2'] = array(
    '#markup' => '<b>Note: </b>Users will be redirected to your IdP for login in case user is not logged in and tries to access website.<br><br>',
  );

  $form['miniorange_saml_auto_redirect'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>auto redirect the user to IdP  <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a></b>'),
    '#default_value' => variable_get('miniorange_saml_auto_redirect_to_idp'),
	'#disabled' => TRUE,
  );

  $form['markup_3'] = array(
    '#markup' => '<b>Note: </b>Users will be redirected to your IdP for login when the login page is accessed.<br><br>',
  );

  $form['miniorange_saml_enable_backdoor'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to enable <b>backdoor login  <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a></b>'),
    '#default_value' => variable_get('miniorange_saml_enable_backdoor', ''),
	'#disabled' => TRUE,
  );

  $form['markup_4'] = array(
    '#markup' => '<b>Note: </b>Checking this option <b>creates a backdoor to login to your Website using Drupal credentials</b><br>'
    . ' incase you get locked out of your IdP. Note down this URL: <code style="background-color:gainsboro;">'
        .'<b><a>' . $base_url . '/?saml_login=false</a></b></code><br><br>',
  );

     $form['miniorange_saml_default_relaystate'] = array(
         '#type' => 'textfield',
         '#title' => t('Default Redirect URL after login  <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
         '#default_value' => variable_get('miniorange_saml_default_relaystate', ''),
         '#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Default Redirect URL'),
         '#disabled' => TRUE,
     );

     $form['miniorange_saml_gateway_config_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#submit' => array('miniorange_saml_save_signin_settings'),
         '#disabled' => TRUE,
     );

     $form['markup_support_1'] = array(
         '#markup' => '</div><div class="mo_saml_table_layout_support_1"><h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
     );

     $form['miniorange_saml_email_address'] = array(
         '#type' => 'textfield',
         '#title' => t('Email Address'),
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your email'),
         '#required' => TRUE,
     );

     $form['miniorange_saml_phone_number'] = array(
         '#type' => 'textfield',
         '#title' => t('Phone number'),
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number'),
     );

     $form['miniorange_saml_support_query'] = array(
         '#type' => 'textarea',
         '#title' => t('Query'),
         '#cols' => '10',
         '#rows' => '5',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here'),
         '#required' => TRUE,
     );

     $form['miniorange_saml_support_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Submit Query'),
         '#submit' => array('miniorange_saml_send_query'),
     );

  return $form;

 }
 function miniorange_saml_save_signin_settings($form, &$form_state) {

 	drupal_set_message(t('Signin Settings successfully saved'));

 }


/**
 * Send support query.
 */
function miniorange_saml_send_query($form, &$form_state) {
    $email = $form['miniorange_saml_email_address']['#value'];
    $phone = $form['miniorange_saml_phone_number']['#value'];
    $query = $form['miniorange_saml_support_query']['#value'];
    $support = new MiniOrangeSamlSupport($email, $phone, $query);
    $support_response = $support->sendSupportQuery();
    if($support_response) {
        drupal_set_message(t('Support query successfully sent'));
    }
    else {
        drupal_set_message(t('Error sending support query'), 'error');
    }
}