<?php
/**
 * @file
 * Contains Attribute and Role Mapping for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
 function miniorange_saml_mapping($form, &$form_state)
 {
     global $base_url;


   
  if (variable_get('miniorange_saml_customer_admin_email', NULL) == NULL || variable_get('miniorange_saml_customer_id', NULL) == NULL
    || variable_get('miniorange_saml_customer_admin_token', NULL) == NULL || variable_get('miniorange_saml_customer_api_key', NULL) == NULL) {
      $register_url = $base_url . '/admin/config/people/miniorange_saml/customer_setup/';
      $form['header'] = array(
          '#markup' => '<div class="mo_saml_idp_message"><h3>You need to <a href="'.$register_url.'" >register</a> with miniOrange before using this module.</h3></center>',
      );

    return $form;
  }

     $form['markup_msg'] = array(
         '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
     );

  global $base_url;

     $form['markup_1'] = array(
         '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout container"><h2>Attribute Mapping</h2><hr><br>');

  $form['miniorange_saml_account_username_by'] = array(
    '#type' => 'select',
    '#title' => t('Login/Create Drupal account by'),
    '#options' => array(1 => t('Username'), 2 => t('Email')),
    '#default_value' => variable_get('miniorange_saml_login_by'),
    '#attributes' => array('style' => 'width:68%')
  );

  $form['miniorange_saml_username_attribute'] = array(
    '#type' => 'textfield',
    '#title' => t('Username Attribute <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
    '#default_value' => variable_get('miniorange_saml_username_attribute', 'NameID'),
    '#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Username attribute'),
	'#disabled' => TRUE,
  );

  $form['miniorange_saml_email_attribute'] = array(
    '#type' => 'textfield',
    '#title' => t('Email Attribute <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
    '#default_value' => variable_get('miniorange_saml_email_attribute', 'NameID'),
    '#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Email attribute'),
	'#disabled' => TRUE,
  );
  
$form['miniorange_saml_idp_attr1_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Role <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Role Attribute'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
 
  $form['markup_cam'] = array(
    '#markup' => '<br><h3>Custom Attribute Mapping: <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a></h3>
    <div class="mo_saml_highlight_background_note_1">Add the Drupal field attributes in the Attribute Name textfield and add the IdP attibutes that you need to map with the drupal attributes in the IdP Attribute Name textfield. Drupal Field Attributes will be of type text. Add the machine name of the attribute in the Drupal Attribute textfield.</br></div>
    <p><b>For example : </b>If the attribute name in the drupal is name then its machine name will be field_name.</p>',
  );
  
 
  
   $form['miniorange_saml_attr5_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 1 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_attr5_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr5_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 1 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_idp_attr5_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr2_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 2 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_attr2_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr2_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 2 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_idp_attr2_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr3_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 3 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_attr3_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr3_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 3 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_idp_attr3_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_attr4_name'] = array(
	'#type' => 'textfield',
	'#title' => t('Attribute Name 4 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_attr4_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  $form['miniorange_saml_idp_attr4_name'] = array(
	'#type' => 'textfield',
	'#title' => t('IdP Attribute Name 4 <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_idp_attr4_name', ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter IdP Attribute Name'),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );

     $form['markup_idp_user_attr_header'] = array(
         '#markup' => '<br /><h3> Additional User Attributes(Optional) <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a> <input type="button" class="btn btn-primary" style="width:3%;margin-left:2%;margin-right:2%;" value="+" onclick="add_user_attibute();" /> <input type="button" class="btn btn-danger" style="width:3%;" value="-" onclick="remove_user_attibute();" /></h3>',
     );

     $form['markup_idp_user_attr_note'] = array(
         '#markup' => '<div class="messages status">Attribute Name: It is the user attribute (machine name) whose value you want to set in site.<br />IdP Attribute Name: It is the name which you want to get from your IDP. It should be unique.</div>',
     );
  
   $form['markup_role'] = array(
    '#markup' => '</br></br><h3>Custom Role Mapping: </h3>',
  );
  
 

   $form['miniorange_saml_enable_rolemapping'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>enable Role Mapping</b>'),
    '#default_value' => variable_get('miniorange_saml_enable_rolemapping'),
  );

    $form['miniorange_disable_attribute'] = array(
    '#type' => 'checkbox',
    '#title' => t('Do not update existing user&#39;s role <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
  '#disabled' => TRUE,
  );
  
   $form['miniorange_saml_disable_role_update'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you do not want to update user role if roles not mapped. <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#disabled' => TRUE,
  );  
  
   $form['miniorange_saml_disable_autocreate_users'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to disable <b>auto creation</b> of users if user does not exist. <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
    '#default_value' => variable_get('miniorange_saml_disable_autocreate_users', ''),
	'#disabled' => TRUE,
  );
  
	$mrole= user_roles($membersonly = TRUE);
	$drole = array_search(variable_get('miniorange_saml_default_role',''),$mrole);
  
   $form['miniorange_saml_default_mapping'] = array(
    '#type' => 'select',
	'#title' => t('Select default group for the new users'),
	'#options' => $mrole,
	'#default_value' => $drole,
    '#attributes' => array('style' => 'width:68%')
   );
    
	foreach($mrole as $roles) {
    $rolelabel = str_replace(' ','',$roles);
    $form['miniorange_saml_role_' . $rolelabel] = array(
	'#type' => 'textfield',
	'#title' => t($roles. '<a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a>'),
	'#default_value' => variable_get('miniorange_saml_role_' . $rolelabel, ''),
	'#attributes' => array('style' => 'width:68%','placeholder' => 'Semi-colon(;) separated Group/Role value for ' . $roles),
	'#required' => FALSE,
	'#disabled' => TRUE,
  );
  
  }
  
   $form['markup_role_signin'] = array(
    '#markup' => '</br><h3>Custom Login/Logout (Optional): <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[PREMIUM]</b></a></h3>'
  );
  
	foreach($mrole as $drupalKey=>$drupalRoles) {
		
		$lbl = str_replace(' ','',$drupalRoles . '_sin');
		$l= str_replace(' ','',$drupalRoles . '_sout');
	
		$form[$lbl] = array(
			'#type' => 'textfield',
			'#title' => $drupalRoles,
			'#default_value' => variable_get($lbl, ''),
			'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Login URL'),
			'#required' => FALSE,
			'#disabled' => TRUE,
		 );

		$form[$l] = array(
			'#type' => 'textfield',
			'#default_value' => variable_get($l, ''),
			'#attributes' => array('style' => 'width:68%','placeholder' => 'Enter Logout URL'),
			'#required' => FALSE,
			'#disabled' => TRUE,
		 );
	
	}
	
  $form['miniorange_saml_gateway_config_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Configuration'),
    '#submit' => array('miniorange_saml_save_mapping_settings'),
  );

     $form['markup_support_1'] = array(
         '#markup' => '</div><div class="mo_saml_table_layout_support_1"><h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
     );

     $form['miniorange_saml_email_address'] = array(
         '#type' => 'textfield',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your email'),
     );

     $form['miniorange_saml_phone_number'] = array(
         '#type' => 'textfield',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number'),
     );

     $form['miniorange_saml_support_query'] = array(
         '#type' => 'textarea',
         '#cols' => '10',
         '#rows' => '5',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here'),
     );

     $form['miniorange_saml_support_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Submit Query'),
         '#submit' => array('miniorange_saml_send_query'),
     );

  return $form;

 }
 
  function miniorange_saml_save_mapping_settings($form, &$form_state) {
  
  $enable_rolemapping = $form['miniorange_saml_enable_rolemapping']['#value'];

  $mrole= user_roles($membersonly = TRUE);	
  $login_by = $form['miniorange_saml_account_username_by']['#value'];
  $username_attribute = $form['miniorange_saml_username_attribute']['#value'];
  $email_attribute = $form['miniorange_saml_email_attribute']['#value'];
  $default_mapping= $form['miniorange_saml_default_mapping']['#value'];
 	
	if($enable_rolemapping == 1) {
		$enable_rolemapping = TRUE;
	}
	else {
		$enable_rolemapping = FALSE;
	}
  
  variable_set('miniorange_saml_enable_rolemapping', $enable_rolemapping);
  if($enable_rolemapping) {
  
		variable_set('miniorange_saml_default_role', $mrole[$default_mapping]);
    }
  
  else {
  
		variable_set('miniorange_saml_default_role', $mrole[2]);
    }
  variable_set('miniorange_saml_login_by', $login_by);
  variable_set('miniorange_saml_username_attribute', $username_attribute);
  variable_set('miniorange_saml_email_attribute', $email_attribute);
  	
  drupal_set_message(t('Signin Settings successfully saved'));

  }

/**
 * Send support query.
 */
function miniorange_saml_send_query($form, &$form_state) {
    $email = $form['miniorange_saml_email_address']['#value'];
    $phone = $form['miniorange_saml_phone_number']['#value'];
    $query = $form['miniorange_saml_support_query']['#value'];
    $support = new MiniOrangeSamlSupport($email, $phone, $query);
    $support_response = $support->sendSupportQuery();
    if($support_response) {
        drupal_set_message(t('Support query successfully sent'));
    }
    else {
        drupal_set_message(t('Error sending support query'), 'error');
    }
}