<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

 /**
 * Showing IdP Setup form info.
 */
 function miniorange_saml_proxy_setup($form, &$form_state) {

     $form['markup_msg'] = array(
         '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
     );


  $form['header1'] = array(
    '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout container"><h3>Configure Proxy Server</h3><hr><br>',
  ); 
  
  $form['header2'] = array(
    '#markup' => 'Enter the information to setup the proxy server.',
  ); 
  
  $form['miniorange_saml_proxy_host'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy Host Name'),
    '#default_value' => variable_get('miniorange_saml_proxy_host', ''),
    '#attributes' => array('style' => 'width:68%','placeholder' => 'Enter the host name'),
  );
  
  $form['miniorange_saml_proxy_port'] = array(
    '#type' => 'textfield',
    '#title' => t('Port Number'),
    '#default_value' => variable_get('miniorange_saml_proxy_port', ''),
    '#attributes' => array('style' => 'width:68%','placeholder' => 'Enter the port number of the proxy'),
  );
  
  $form['miniorange_saml_proxy_username'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy Username'),
    '#default_value' => variable_get('miniorange_saml_proxy_username', ''),
    '#attributes' => array('style' => 'width:68%','placeholder' => 'Enter the username of the proxy server'),
  );
  
  $form['miniorange_saml_proxy_password'] = array(
    '#type' => 'password',
    '#title' => t('Password'),
    '#default_value' => variable_get('miniorange_saml_proxy_password', ''),
    '#attributes' => array('style' => 'width:68%','placeholder' => 'Enter the password of the poxy server'),
  );

  $form['miniorange_saml_proxy_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('miniorange_saml_save_proxy'),
  );

     $form['markup_support_1'] = array(
         '#markup' => '</div><div class="mo_saml_table_layout_support_1"><h3>Support</h3></h3><div>Need any help? Just send us a query so we can help you.<br /><br /></div>',
     );

     $form['miniorange_saml_email_address'] = array(
         '#type' => 'textfield',
         '#title' => t('Email Address'),
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your email'),
     );

     $form['miniorange_saml_phone_number'] = array(
         '#type' => 'textfield',
         '#title' => t('Phone number'),
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Enter your phone number'),
     );

     $form['miniorange_saml_support_query'] = array(
         '#type' => 'textarea',
         '#title' => t('Query'),
         '#cols' => '10',
         '#rows' => '5',
         '#attributes' => array('style' => 'width:100%','placeholder' => 'Write your query here'),
     );

     $form['miniorange_saml_support_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Submit Query'),
         '#submit' => array('miniorange_saml_send_query'),
     );

  return $form;

 }

 /**
 * Configure Proxy Server.
 */

function miniorange_saml_save_proxy($form, &$form_state) {
  
  $proxy_host = $form['miniorange_saml_proxy_host']['#value'];
  $port_number = $form['miniorange_saml_proxy_port']['#value'];
  $proxy_username = $form['miniorange_saml_proxy_username']['#value'];
  $proxy_password = $form['miniorange_saml_proxy_password']['#value'];

  variable_set('miniorange_saml_proxy_host',$proxy_host);
  variable_set('miniorange_saml_proxy_port',$port_number);
  variable_set('miniorange_saml_proxy_username',$proxy_username);
  variable_set('miniorange_saml_proxy_password',$proxy_password );

  
  drupal_set_message(t('Your configuration has been saved successfully.'));

}

/**
 * Send support query.
 */
function miniorange_saml_send_query($form, &$form_state) {
    $email = $form['miniorange_saml_email_address']['#value'];
    $phone = $form['miniorange_saml_phone_number']['#value'];
    $query = $form['miniorange_saml_support_query']['#value'];
    $support = new MiniOrangeSamlSupport($email, $phone, $query);
    $support_response = $support->sendSupportQuery();
    if($support_response) {
        drupal_set_message(t('Support query successfully sent'));
    }
    else {
        drupal_set_message(t('Error sending support query'), 'error');
    }
}